/*
Copyright © 2025 Jake jake.young.dev@gmail.com
*/
package command

import (
	"fmt"

	"code.jakeyoungdev.com/jake/mctl/database"
	"github.com/spf13/cobra"
)

var viewCmd = &cobra.Command{
	Use:          "view",
	Example:      "mctl command view",
	Short:        "view all saved commands",
	SilenceUsage: true,
	Run: func(cmd *cobra.Command, args []string) {
		db, err := database.New()
		cobra.CheckErr(err)
		defer db.Close()

		ts, err := db.GetAllCmds()
		if err != nil {
			if err.Error() == ErrInit {
				fmt.Println(ErrInitRsp)
				return
			}
		}
		cobra.CheckErr(err)

		for _, s := range ts {
			fmt.Println("-----")
			fmt.Printf("Name: %s\n", s.Name)
			fmt.Printf("Command: %s\n", s.Command)
		}
	},
}

func init() {
	CommandCmd.AddCommand(viewCmd)
}
