/*
Copyright © 2025 Jake jake.young.dev@gmail.com
*/
package cmd

import (
	"code.jakeyoungdev.com/jake/mctl/database"
	"github.com/spf13/cobra"
)

var initCmd = &cobra.Command{
	Use:          "init",
	Example:      "mctl init",
	Short:        "initializes the database tables, must be run before mctl can be used",
	SilenceUsage: true,
	Run: func(cmd *cobra.Command, args []string) {
		db, err := database.New()
		cobra.CheckErr(err)
		defer db.Close()

		err = db.Init()
		cobra.CheckErr(err)
	},
}

func init() {
	rootCmd.AddCommand(initCmd)
}
