/*
Copyright © 2025 Jake jake.young.dev@gmail.com
*/
package server

import (
	"github.com/spf13/cobra"
)

const (
	//sqlite doesn't have an error type for this error, but we want to catch when this error is thrown
	//and provide the proper response. It should not be treated as an error if the db isn't setup.
	ErrInit    = "sqlite3: SQL logic error: no such table: servers"
	ErrInitRsp = "The 'init' command must be run before mctl can be used"
)

var ServerCmd = &cobra.Command{
	Use:     "server",
	Example: "mctl server <subcommand>",
}

func init() {}
